library endlich;

import 'package:freezed_annotation/freezed_annotation.dart';

export 'src/machine.dart';

part 'endlich.freezed.dart';

@freezed
class Endlich with _$Endlich {
  const factory Endlich() = EndlichMachine;
  const factory Endlich.event(Type target, {String? guard}) = EndlichEvent;
  const factory Endlich.state({String? effect}) = EndlichState;
  const factory Endlich.initial() = EndlichInitialState;
}
